<?php

namespace Drupal\datahub_webform_handler\Service;

use Drupal\Core\DependencyInjection\ServiceProviderBase;

/**
 * Creating the response to submit in api.
 */
class BodyValues extends ServiceProviderBase {

  /**
   * Default generateTokensByResourceOwner implementation.
   *
   * @inheritDoc
   */
  public function formValues($user_field_data, $webform_uuid, $submission_uuid, $webform_name, $queryParams, $response) {
    $utmSource = '';
    $utmMedium = '';
    $utmCampaign = '';
    $utmContent = '';
    $utmTerm = '';
    $utmEmailName = '';
    $utmRefCode = '';
    $firstName = '';
    $surname = '';
    $emailAddress = '';
    $websiteURL = '';
    $phoneNumberBaseNumber = '';
    $addressCountry = '';
    $country_code = 'NA';
    $gender = '';
    $jobTitle = '';
    $companyName = '';
    $jobFunction = '';
    $industry = '';
    $interest = '';
    $eventEditionCode = 'EME23FST';
    $countryCode = '';
    $marketingOptIn = 'Yes';
    $marketingOptInPrefType = "Implicit";
    $registrationStatus = "RS_REGSTR";
    $interests = [];

    if (isset($user_field_data['eventEditionCode'])) {
      $eventEditionCode = $user_field_data['eventEditionCode'];
    }
    if (isset($queryParams['utm_content'])) {
      $utmContent = $queryParams['utm_content'];
    }
    if (isset($queryParams['utm_source'])) {
      $utmSource = $queryParams['utm_source'];
    }
    if (isset($queryParams['utm_medium'])) {
      $utmMedium = $queryParams['utm_medium'];
    }
    if (isset($queryParams['utm_campaign'])) {
      $utmCampaign = $queryParams['utm_campaign'];
    }
    if (isset($queryParams['utm_emailname'])) {
      $utmEmailName = $queryParams['utm_emailname'];
    }
    if (isset($queryParams['utm_term'])) {
      $utmTerm = $queryParams['utm_term'];
    }
    if (isset($queryParams['utm_refcode'])) {
      $utmRefCode = $queryParams['utm_refcode'];
    }
    if (isset($user_field_data['firstName'])) {
      $firstName = $user_field_data['firstName'];
    }
    if (isset($user_field_data['surname'])) {
      $surname = $user_field_data['surname'];
    }
    if (isset($user_field_data['email'])) {
      $emailAddress = $user_field_data['email'];
    }
    if (isset($user_field_data['addressCountry'])) {
      $addressCountry = $user_field_data['addressCountry']['country'];

      // Get the countries service.
      $countries = \Drupal::service('country_manager')->getList();

      // Search for the country code by name.
      $country_code = array_search($addressCountry, $countries);

    }
    if (isset($user_field_data['phoneNumberBaseNumber'])) {
      $phoneNumberBaseNumber = $user_field_data['phoneNumberBaseNumber'];
      $parts = explode(' ', $phoneNumberBaseNumber);
      // Get the value before the first space.
      $countryCode = $parts[0];
      $phoneNumberBaseNumber = substr($phoneNumberBaseNumber, strpos($phoneNumberBaseNumber, ' ') + 1);
    }
    if (isset($user_field_data['websiteURL'])) {
      $websiteURL = $user_field_data['websiteURL'];
    }
    if (isset($user_field_data['gender'])) {
      $gender = $user_field_data['gender'];
    }
    if (isset($user_field_data['jobTitle'])) {
      $jobTitle = $user_field_data['jobTitle'];
    }
    if (isset($user_field_data['jobFunction'])) {
      $jobFunction = $user_field_data['jobFunction'];
    }
    if (isset($user_field_data['companyName'])) {
      $companyName = $user_field_data['companyName'];
    }
    if (isset($user_field_data['industry'])) {
      $industry = $user_field_data['industry'];
    }
    if (isset($user_field_data['interest'])) {
      $interests = $user_field_data['interest'];
    }

    if (isset($user_field_data['visitorType'])) {
      $visitorType = $user_field_data['visitorType'];
    }
    if (isset($user_field_data['getInTouch'])) {
      $getInTouch = $user_field_data['getInTouch'];
    }
    if (isset($user_field_data['registrationStatus'])) {
      $registrationStatus = $user_field_data['registrationStatus'];
    }
    if (isset($user_field_data['getInTouch'])) {
      $getInTouch = $user_field_data['getInTouch'];
      if ($getInTouch == '1') {
        $thirdPartyOptins = 'No';
        $thirdPartyOptInPrefTypes = "Explicit";
      }
      else {
        $thirdPartyOptins = 'Yes';
        $thirdPartyOptInPrefTypes = "Implicit";
      }
    }
    if (isset($user_field_data['eventsAndProduct'])) {
      $eventsAndProduct = $user_field_data['eventsAndProduct'];
      if ($eventsAndProduct == '1') {
        $marketingOptIn = 'No';
        $marketingOptInPrefType = "Explicit";
      }
    }

    if (isset($user_field_data['CPHIMilanLatestProductsServices'])) {
      if ($user_field_data['CPHIMilanLatestProductsServices'] == 'yes') {
        $marketingOptIn = 'Yes';
        $marketingOptInPrefType = "Explicit";
      }
      if ($user_field_data['CPHIMilanLatestProductsServices'] == 'no') {
        $marketingOptIn = 'No';
        $marketingOptInPrefType = "Explicit";
      }
    }
    if (isset($user_field_data['CPHIMilanPartnersProductsServices'])) {
      if ($user_field_data['CPHIMilanPartnersProductsServices'] == 'yes') {
        $thirdPartyOptins = 'Yes';
        $thirdPartyOptInPrefTypes = "Explicit";
      }
      if ($user_field_data['CPHIMilanPartnersProductsServices'] == 'no') {
        $thirdPartyOptins = 'No';
        $thirdPartyOptInPrefTypes = "Explicit";
      }
    }
    if (isset($user_field_data['CPHIMilanEvents'])) {
      $cphiMilanEvents = $user_field_data['CPHIMilanEvents'];
      if ($cphiMilanEvents == '1') {
        $marketingOptIn = 'No';
        $marketingOptInPrefType = "Explicit";
      }
    }

    if (isset($user_field_data['privacyTerms'])) {
      $privacyTerms = $user_field_data['privacyTerms'];
      if ($privacyTerms == '1') {
        $marketingOptIn = 'Yes';
        $marketingOptInPrefType = "Explicit";
        $thirdPartyOptins = 'Yes';
        $thirdPartyOptInPrefTypes = "Explicit";
      }
      if ($privacyTerms == '0') {
        $marketingOptIn = 'No';
        $marketingOptInPrefType = "Explicit";
        $thirdPartyOptins = 'No';
        $thirdPartyOptInPrefTypes = "Explicit";
      }
    }

    $response = [
      "AttendeeRegistration" => [
        "Profile" => [
          "firstName" => $firstName,
          "surname" => $surname,
          "title" => $gender,
          "gender" => $gender,
          "sourceSystem" => 'SS_DRUPAL',
          "contactInformation" => [
            "email" => [
              [
                "emailClass" => "BUSINESS",
                "emailAddress" => $emailAddress,
              ],
            ],
            "address" => [
              [
                "ADDRESS_CATEGORY" => 'AC_PRMRY',
                "ADDRESS_CLASS" => 'BUSINESS',
                "ADDRESS_TYPE" => 'AT_BLNG',
                "addressCountry" => $country_code,
              ],
            ],
            "phone" => [
              [
                "phoneNumberClass" => "BUSINESS",
                "phoneNumberType" => "MOBILE",
                "phoneNumberCategory" => "PNC_PRMRY",
                "phoneNumberCountrycode" => $countryCode,
                "phoneNumberBaseNumber" => $phoneNumberBaseNumber,
              ],
            ],
          ],
          "organization" => [
            "organizationAliasName" => $companyName,
            "natureOfBusiness" => [[
              "SIC" => $industry,
            ],
            ],
            "jobFunction" => $jobFunction,
            "jobTitle" => $jobTitle,
          ],
          "preferences" => [
            "communicationPreferences" => [
              "marketingOptIn" => $marketingOptIn,
              "marketingOptInPrefType" => $marketingOptInPrefType,
              "similarEventsOptIn" => "SE_OPTOUT",
              "similarEventsOptInPrefType" => "Implicit",
              "thirdpartyOptIn" => $thirdPartyOptins,
              "thirdPartyOptInPrefType" => $thirdPartyOptInPrefTypes,
              "thirdPartySpecific" => [[
                "thirdParty" => "IBM",
                "thirdPartyOptin" => $thirdPartyOptins,
                "thirdPartyOptinPreftype" => $thirdPartyOptInPrefTypes,
              ],
              ],
            ],
            "communicationPreferedChannels" => [
              "emailPreference" => 'Yes',
              "phonePreference" => 'Yes',
              "directPostPreference" => 'Yes',
              "smsPreference" => 'Yes',
            ],
          ],
        ],
        "contactSessionHistory" => [
          "eventEditionCode" => $eventEditionCode,
          "utmCampaign" => $utmCampaign,
          "utmContent" => $utmContent,
          "utmMedium" => $utmMedium,
          "utmRefCode" => $utmRefCode,
          "utmSource" => $utmSource,
          "utmTerm" => $utmTerm,
          "formName" => $webform_name,
          "Session" => [
            [
              "actionDateTime" => date("d-m-Y\TH:i:s"),
              "visitorType" => $visitorType,
              "websiteURL" => $websiteURL,
              "track" => [
                "trackCode" => "T_EXHB",
                "trackName" => "Exhibition",
              ],
              "sessionName" => "Exhibition",
              "sessionCode" => "S_EXHB",
              "sessionType" => "Exhibition",
              "uniqueRefereceNumber" => $submission_uuid,
              "registrationStatus" => $registrationStatus,
              "interest" => [],
            ],
          ],
        ],
      ],
    ];
    foreach ($interests as $interest) {
      $response["AttendeeRegistration"]["contactSessionHistory"]["Session"][0]["interest"][] = [
        "interestCode" => $interest,
      ];
    }
    return $response;
  }

}
