<?php

namespace Drupal\datahub_webform_handler\Service;

use Drupal\Core\DependencyInjection\ServiceProviderBase;

/**
 * Datahub services call.
 */
class DatahubIntegration extends ServiceProviderBase {

  /**
   * Default generateTokensByResourceOwner implementation.
   *
   * @inheritDoc
   */
  public function sentWebformSubmissionTodatahub($submittedValue, $accessToken) {
    $jsonString = json_encode($submittedValue);
    $config = \Drupal::config('webform_datahub.settings');
    $endpoint_api_url = $config->get('endpoint_api') . "/api/attendee/registration";
    $http_client = \Drupal::service('http_client');
    // URL to which you want to make the POST request.
    try {
      // Make the POST request.
      $response = $http_client->post($endpoint_api_url, [
        'json' => $submittedValue,
        'headers' => [
      // Adjust the content type as needed.
          'Content-Type' => 'application/json',
          'token' => $accessToken,
        ],
      ]);

      // Get the response body.
      $response_body = $response->getBody()->getContents();
      // Handle the response data as needed.
      // For example, output the response body.
      \Drupal::logger('webform_datahub response_body')->notice('<pre><code>' . print_r($response_body, TRUE) . '</code></pre>');
      \Drupal::logger('webform_datahub response')->notice('<pre><code>' . print_r($jsonString, TRUE) . '</code></pre>');
      // drupal_set_message('Response: ' . $response_body);.
    }
    catch (RequestException $e) {
      // Handle exceptions or errors.
      // drupal_set_message('Error: ' . $e->getMessage(), 'error');.
      $message = $e->getMessage();
      \Drupal::logger('webform_datahub response_body')->notice('<pre><code>' . print_r($response_body, TRUE) . '</code></pre>');
    }
  }

}
