<?php

namespace Drupal\datahub_webform_handler\Service;

use Drupal\Core\DependencyInjection\ServiceProviderBase;

/**
 * Genrating the accesstoken.
 */
class GetAccessToken extends ServiceProviderBase {

  /**
   * Default generateTokensByResourceOwner implementation.
   *
   * @inheritDoc
   */
  public function accessToken() {
    $response_body = '';
    $config = \Drupal::config('webform_datahub.settings');
    $user = $config->get('username');
    $pass = $config->get('password_field');
    $endpoint_api_url = $config->get('endpoint_api') . "/api/secure/token";

    // URL to which you want to make the POST request.
    try {
      $client = \Drupal::httpClient()->post($endpoint_api_url, [
        'headers' => [
      // Adjust the content type as needed.
          'Content-Type' => 'application/json',
          'username' => $user,
          'password' => $pass,
        ],
      ]);

      $response_body = $client->getBody()->getContents();
    }
    catch (\Throwable $e) {
      \Drupal::logger('AccessToken Not Generated')->notice('<pre><code>' . print_r("username or Password is incorrect", TRUE) . '</code></pre>');
    }

    return $response_body;
  }

}
